> ## Documentation Index
> Fetch the complete documentation index at: https://docs.chainstream.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Wallet - Balance Updates

> Get wallet balance change history with filtering and pagination



## OpenAPI

````yaml /en/api-reference/openapi-data-en.yaml GET /v2/wallet/{chain}/{walletAddress}/balance-updates
openapi: 3.1.0
info:
  title: Services API
  description: Services API
  contact:
    name: AI
    email: ai@sx.ai
  license:
    name: MIT
  version: '1.0'
servers:
  - url: https://api.chainstream.io
    description: Production
security:
  - bearer_auth: []
  - api_key_auth: []
tags:
  - name: Blockchain
    description: Blockchain related operations
  - name: Token
    description: Token related operations
  - name: Trade
    description: Trade related operations
  - name: Wallet
    description: Wallet related operations
  - name: Dex
    description: Dex related operations
  - name: Ranking
    description: Ranking related operations
  - name: DexPool
    description: DexPool related operations
  - name: Watchlist
    description: Watchlist related operations
  - name: KYT
    description: Kyt related operations
  - name: Webhook
    description: Webhook related operations
  - name: RedPacket
    description: Redpacket related operations
  - name: IPFS
    description: Ipfs related operations
  - name: DexScreener
    description: DexScreener related operations
paths:
  /v2/wallet/{chain}/{walletAddress}/balance-updates:
    get:
      tags:
        - Wallet
      summary: Wallet - Balance Updates
      description: Get wallet balance change history with filtering and pagination
      operationId: get.balance.updates
      parameters:
        - name: chain
          in: path
          description: A chain name listed in supported networks
          required: true
          schema:
            $ref: '#/components/schemas/ChainSymbol'
          example: sol
        - name: walletAddress
          in: path
          description: An address of a wallet
          required: true
          schema:
            type: string
          example: MJKqp326RZCHnAAbew9MDdui3iCKWco7fsK9sVuZTX2
        - name: cursor
          in: query
          description: Pagination cursor
          required: false
          schema:
            type: string
          example: eyJpZCI6IjEyMyJ9
        - name: limit
          in: query
          description: Number of results per page
          required: false
          schema:
            type: integer
            format: int64
            default: 20
          example: 20
        - name: direction
          in: query
          description: Pagination direction (next or prev)
          required: false
          schema:
            oneOf:
              - $ref: '#/components/schemas/PageDirection'
            default: next
          example: next
        - name: tokenAddress
          in: query
          description: An address of a token
          required: false
          schema:
            type: string
          example: FBmHMoWzwJB3g9GCSNTn1ZyvgkuZs7c8GTgNDoJNpump
        - name: timeFrom
          in: query
          description: Start timestamp (Unix epoch in seconds)
          required: false
          schema:
            type: integer
            format: int64
          example: 1705312800000
        - name: timeTo
          in: query
          description: End timestamp (Unix epoch in seconds)
          required: false
          schema:
            type: integer
            format: int64
          example: 1705399200000
        - name: type
          in: query
          description: Balance type filter (SOL for native, SPL for tokens)
          required: false
          schema:
            $ref: '#/components/schemas/BalanceTokenType'
          example: SPL
        - name: changeType
          in: query
          description: Balance change direction filter (INCREASE or DECREASE)
          required: false
          schema:
            $ref: '#/components/schemas/BalanceChangeType'
          example: INCREASE
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PageResponse_BalanceUpdate'
components:
  schemas:
    ChainSymbol:
      type: string
      description: Supported blockchain chains
      enum:
        - sol
        - eth
        - bsc
    PageDirection:
      type: string
      description: Pagination direction
      enum:
        - next
        - prev
    BalanceTokenType:
      type: string
      description: Balance token type
      enum:
        - SOL
        - SPL
    BalanceChangeType:
      type: string
      description: Balance change type
      enum:
        - INCREASE
        - DECREASE
    PageResponse_BalanceUpdate:
      type: object
      description: Generic pagination response
      required:
        - data
      properties:
        data:
          type: array
          items:
            type: object
            description: Balance update record
            required:
              - blockHash
              - blockHeight
              - blockTimestamp
              - transactionSignature
              - index
              - tokenAddress
              - tokenAccountAddress
              - accountOwnerAddress
              - preBalance
              - preBalanceInNative
              - preBalanceInUsd
              - postBalance
              - postBalanceInNative
              - postBalanceInUsd
              - balanceChange
              - balanceChangeInNative
              - balanceChangeInUsd
              - type
              - changeType
            properties:
              accountOwnerAddress:
                type: string
                description: Account owner wallet address
              balanceChange:
                type: string
                description: Balance change amount
              balanceChangeInNative:
                type: string
                description: Balance change in native token
              balanceChangeInUsd:
                type: string
                description: Balance change in USD
              blockHash:
                type: string
                description: Block hash
              blockHeight:
                type: integer
                format: int64
                description: Block height
              blockSlot:
                type:
                  - integer
                  - 'null'
                format: int64
                description: Block slot number
              blockTimestamp:
                type: integer
                format: int64
                description: Block timestamp (milliseconds)
              changeType:
                $ref: '#/components/schemas/BalanceChangeType'
                description: Balance change direction (INCREASE or DECREASE)
              index:
                type: integer
                format: int64
                description: Transaction instruction index
              postBalance:
                type: string
                description: Balance after the transaction
              postBalanceInNative:
                type: string
                description: Balance after in native token
              postBalanceInUsd:
                type: string
                description: Balance after in USD
              preBalance:
                type: string
                description: Balance before the transaction
              preBalanceInNative:
                type: string
                description: Balance before in native token
              preBalanceInUsd:
                type: string
                description: Balance before in USD
              tokenAccountAddress:
                type: string
                description: Token account address
              tokenAddress:
                type: string
                description: Token contract address
              transactionSignature:
                type: string
                description: Transaction signature
              type:
                $ref: '#/components/schemas/BalanceTokenType'
                description: Token type (SOL for native, SPL for tokens)
          description: Page data
        endCursor:
          type:
            - string
            - 'null'
          description: Cursor for the end of current page
          example: eyJpZCI6ImVuZCJ9
        hasNext:
          type: boolean
          description: Whether there is a next page
          example: false
        hasPrev:
          type: boolean
          description: Whether there is a previous page
          example: false
        startCursor:
          type:
            - string
            - 'null'
          description: Cursor for the start of current page
          example: eyJpZCI6InN0YXJ0In0=
        total:
          type:
            - integer
            - 'null'
          format: int64
          description: >-
            Total number of items matching the query (not just the current
            page).

            When `None`, the caller should treat it as unknown
            (backward-compatible).
          example: 564094
  securitySchemes:
    bearer_auth:
      type: http
      scheme: bearer
      bearerFormat: JWT
    api_key_auth:
      type: apiKey
      in: header
      name: X-API-KEY

````